(ns org.aplex.helpers.core
  (:require [clojure.string :as s])
  #?(:clj (:import (java.lang System))))

(defn map-replace
  "Given a string with {:key} strings substitute the matching key in a hash map"
  [text m]
  (reduce
   (fn [acc [k v]] (s/replace acc (str "{" k "}") (str v)))
   text m))

(defn build-url [root-url path params]
  (str root-url (map-replace path params)))

(defn attach-handler [hm fn]
  (assoc hm :handler fn))

#?(:clj
   (defn get-env [key default-value]
     (or (System/getenv key) default-value)))
