(ns src.frontend.portfolio.stability-ai
  (:require
   [ajax.core
    :refer [ajax-request GET json-request-format json-response-format POST]]
   [org.aplex.helpers.interface :as h]
   [org.aplex.rest-stability-ai.interface :as st]
   [portfolio.dumdom :as d]))

;; api root paths shoudl not end in a slash
;; the payloads should be maps no coupling to http libraries
;; each api should have an init to set the api key and change the host along side any other config

(def temp-response (atom nil))

@st/api-config

(st/fetch-user-account)

(-> (st/fetch-user-account prn)
    (merge {:format (json-request-format)
            :response-format (json-response-format {:keywords? true})})
     ajax-request)

(-> (st/fetch-user-balance prn)
    (merge {:format (json-request-format)
            :response-format (json-response-format {:keywords? true})})
     ajax-request)

(-> (st/fetch-generation-text-to-image (fn [r]
                        (prn r)
                        (reset! temp-response r)) {} {})
    (merge {:format (json-request-format)
            :response-format (json-response-format {:keywords? true})})
     ajax-request)



#_(POST (build-url "/v1/generation/stable-diffusion-v1-5/text-to-image")
     (merge default-authed-payload
            {:handler (fn [r]
                        (prn r)
                        (reset! temp-response r))
             :format :json
             :response-format :json
             :params {:text_prompts [{:text "A wooden hand crafted light house"
                                      :weight 0.5}]}}))



(d/defscene image
  [:div
   [:img {:src (str "data:image/png;base64," (get (first (get @temp-response "artifacts")) "base64")) }]])

(d/defscene card
  [:div.h-96.w-48.flex.justify-center.flex.col.rounded-full.border
   [:div.w-48.h-48
    [:img.object-contain.w-48.h-48.rounded-md
     {:src (str "data:image/png;base64," (get (first (get @temp-response "artifacts")) "base64")) }]]
   [:div "some text"]])

@temp-response

